Crypt_Rijndael

# Class: Crypt_Rijndael

Source Location: /lib/3rdParty/phpseclib/Crypt/Rijndael.php

### Class Overview

Pure-PHP implementation of Rijndael.

#### Author(s):

- Jim Wigginton <terrafrost@php.net>

#### Version:

- 0.1.0

### Methods

- Crypt_Rijndael
- decrypt
- disableContinuousBuffer
- disablePadding
- enableContinuousBuffer
- enablePadding
- encrypt
- setBlockLength
- setIV
- setKey
- setKeyLength
- _generate_xor

### Child classes:

Crypt_AES
  Pure-PHP implementation of AES.

### Class Details

[line 120]
Pure-PHP implementation of Rijndael.

#### Tags:

author: | Jim Wigginton <terrafrost@php.net>
version: | 0.1.0
access: | public

[ Top ]

### Class Methods

### constructor Crypt_Rijndael [line 369]

`Crypt_Rijndael Crypt_Rijndael( [optional $mode = CRYPT_RIJNDAEL_MODE_CBC])`

Default Constructor.

Determines whether or not the mcrypt extension should be used. $mode should only, at present, be CRYPT_RIJNDAEL_MODE_ECB or CRYPT_RIJNDAEL_MODE_CBC. If not explictly set, CRYPT_RIJNDAEL_MODE_CBC will be used.

#### Tags:

access: | public

#### Parameters:

optional | $mode | Integer $mode

[ Top ]

### method decrypt [line 663]

`void decrypt( String $ciphertext)`

Decrypts a message.

If strlen($ciphertext) is not a multiple of the block size, null bytes will be added to the end of the string until it is.

#### Tags:

see: | Crypt_Rijndael::encrypt()
access: | public

Overridden in child classes as:

Crypt_AES::decrypt()
  Decrypts a message.

#### Parameters:

String | $ciphertext |

[ Top ]

### method disableContinuousBuffer [line 1216]

`void disableContinuousBuffer( )`

Treat consecutive packets as if they are a discontinuous buffer.

The default behavior.

#### Tags:

see: | Crypt_Rijndael::enableContinuousBuffer()
access: | public

[ Top ]

### method disablePadding [line 1106]

`void disablePadding( )`

Do not pad packets.

#### Tags:

see: | Crypt_Rijndael::enablePadding()
access: | public

[ Top ]

### method enableContinuousBuffer [line 1203]

`void enableContinuousBuffer( )`

Treat consecutive "packets" as if they are a continuous buffer.

Say you have a 32-byte plaintext $plaintext. Using the default behavior, the two following code snippets will yield different outputs:

1. echo $rijndael-> encrypt ( substr ($plaintext, 0, 16));
2. echo $rijndael-> encrypt ( substr ($plaintext, 16, 16));

1. echo $rijndael-> encrypt ($plaintext);

The solution is to enable the continuous buffer. Although this will resolve the above discrepancy, it creates another, as demonstrated with the following:

1. $rijndael-> encrypt ( substr ($plaintext, 0, 16));
2. echo $rijndael-> decrypt ($des-> encrypt ( substr ($plaintext, 16, 16)));

1. echo $rijndael-> decrypt ($des-> encrypt ( substr ($plaintext, 16, 16)));

With the continuous buffer disabled, these would yield the same output. With it enabled, they yield different outputs. The reason is due to the fact that the initialization vector's change after every encryption / decryption round when the continuous buffer is enabled. When it's disabled, they remain constant.

Put another way, when the continuous buffer is enabled, the state of the Crypt_Rijndael() object changes after each encryption / decryption round, whereas otherwise, it'd remain constant. For this reason, it's recommended that continuous buffers not be used. They do offer better security and are, in fact, sometimes required (SSH uses them), however, they are also less intuitive and more likely to cause you problems.

#### Tags:

see: | Crypt_Rijndael::disableContinuousBuffer()
access: | public

[ Top ]

### method enablePadding [line 1095]

`void enablePadding( )`

Pad "packets".

Rijndael works by encrypting between sixteen and thirty-two bytes at a time, provided that number is also a multiple of four. If you ever need to encrypt or decrypt something that isn't of the proper length, it becomes necessary to pad the input so that it is of the proper length.

Padding is enabled by default. Sometimes, however, it is undesirable to pad strings. Such is the case in SSH, where "packets" are padded with random bytes before being encrypted. Unpad these packets and you risk stripping away characters that shouldn't be stripped away. (SSH knows how many bytes are added because the length is transmitted separately)

#### Tags:

see: | Crypt_Rijndael::disablePadding()
access: | public

[ Top ]

### method encrypt [line 611]

`void encrypt( String $plaintext)`

Encrypts a message.

$plaintext will be padded with additional bytes such that it's length is a multiple of the block size. Other Rjindael implementations may or may not pad in the same manner. Other common approaches to padding and the reasons why it's necessary are discussed in the following URL:

http://www.di-mgt.com.au/cryptopad.html

An alternative to padding is to, separately, send the length of the file. This is what SSH, in fact, does. strlen($plaintext) will still need to be a multiple of 8, however, arbitrary values can be added to make it that length.

#### Tags:

see: | Crypt_Rijndael::decrypt()
access: | public

Overridden in child classes as:

Crypt_AES::encrypt()
  Encrypts a message.

#### Parameters:

String | $plaintext |

[ Top ]

### method setBlockLength [line 541]

`void setBlockLength( Integer $length)`

Sets the block length

Valid block lengths are 128, 160, 192, 224, and 256. If the length is less than 128, it will be rounded up to 128. If the length is greater then 128 and invalid, it will be rounded down to the closest valid amount.

#### Tags:

access: | public

Overridden in child classes as:

Crypt_AES::setBlockLength()
  Dummy function

#### Parameters:

Integer | $length |

[ Top ]

### method setIV [line 503]

`void setIV( String $iv)`

Sets the initialization vector. (optional)

SetIV is not required when CRYPT_RIJNDAEL_MODE_ECB is being used. If not explictly set, it'll be assumed to be all zero's.

#### Tags:

access: | public

#### Parameters:

String | $iv |

[ Top ]

### method setKey [line 488]

`void setKey( String $key)`

Sets the key.

Keys can be of any length. Rijndael, itself, requires the use of a key that's between 128-bits and 256-bits long and whose length is a multiple of 32. If the key is less than 256-bits and the key length isn't set, we round the length up to the closest valid key length, padding $key with null bytes. If the key is more than 256-bits, we trim the excess bits.

If the key is not explicitly set, it'll be assumed to be all null bytes.

#### Tags:

access: | public

#### Parameters:

String | $key |

[ Top ]

### method setKeyLength [line 517]

`void setKeyLength( Integer $length)`

Sets the key length

Valid key lengths are 128, 160, 192, 224, and 256. If the length is less than 128, it will be rounded up to 128. If the length is greater then 128 and invalid, it will be rounded down to the closest valid amount.

#### Tags:

access: | public

#### Parameters:

Integer | $length |

[ Top ]

### method _generate_xor [line 566]

`void _generate_xor( Integer $length, &$iv, String $iv)`

Generate CTR XOR encryption key

Encrypt the output of this and XOR it against the ciphertext / plaintext to get the plaintext / ciphertext in CTR mode.

#### Tags:

see: | Crypt_Rijndael::decrypt()
see: | Crypt_Rijndael::encrypt()
access: | public

#### Parameters:

Integer | $length |
String | $iv |
| &$iv |

[ Top ]

Documentation generated on Thu, 28 Oct 2010 21:00:31 +0200 by phpDocumentor 1.4.1